IF 0  ; 
                      Build this template with "CONSOLE ASSEMBLE AND LINK"
ENDIF ; 

    include \masm32\include\masm32rt.inc

    utoa_ex PROTO :DWORD,:DWORD

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL pbuf  :DWORD
    LOCAL buffer[128]:BYTE

    push ebx
    push esi
    push edi

    mov pbuf, ptr$(buffer)
    invoke utoa_ex,1234567890,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa_ex,123456789,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa_ex,12345678,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa_ex,1234567,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa_ex,123456,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa_ex,12345,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa_ex,1234,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa_ex,123,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa_ex,12,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa_ex,1,pbuf
    print pbuf,13,10

    jmp quit    ; comment out to run following exhaustive test

  ; ===========================================

    xor esi, esi
    xor ebx, ebx

  @@:
    add ebx, 1
    mov pbuf, ptr$(buffer)
    invoke utoa_ex,esi,pbuf
    mov edi, ustr$(esi)

    invoke szCmp,pbuf,edi

    .if eax == 0
      print pbuf,13,10
      print "error at "
      print ustr$(esi),13,10
    .endif

    .if ebx > 1024*1024*2
      print "."
      xor ebx, ebx
    .endif

    add esi, 1

    cmp esi, -1
    jb @B

  quit:

    pop edi
    pop esi
    pop ebx

    ret

main endp

;  

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

  ; ---------------------------------------------------------
  ; Lingo (decyphered) modification of Paul Dixon's algorithm
  ; ---------------------------------------------------------

utoa_ex proc src:DWORD, lpdest:DWORD

    .data
	align 16
        chartabL dw "00","10","20","30","40","50","60","70","80","90"
                 dw "01","11","21","31","41","51","61","71","81","91"
                 dw "02","12","22","32","42","52","62","72","82","92"
                 dw "03","13","23","33","43","53","63","73","83","93"
                 dw "04","14","24","34","44","54","64","74","84","94"
                 dw "05","15","25","35","45","55","65","75","85","95"
                 dw "06","16","26","36","46","56","66","76","86","96"
                 dw "07","17","27","37","47","57","67","77","87","97"
                 dw "08","18","28","38","48","58","68","78","88","98"
                 dw "09","19","29","39","49","59","69","79","89","99"
    .code

    mov eax, [esp+4]                        ; eax->number
    mov edx, 0D1B71759h                     ; =2^45\10000    13 bit extra shift
    mov ecx, [esp+8]                        ; ecx-> lpResult
    mov [esp+4], edi                        ; save edi
    mov edi, eax                            ; save a copy of the number
    mul edx                                 ; gives 6 high digits in edx
    mov [esp+8], esi                        ; save esi
    shr edx, 13                             ; correct for multiplier offset used to give better accuracy
    mov eax, 68DB9h                         ; =2^32\10000+1
    je lbl11                                ; if zero then dont need to process the top 6 digits
    imul esi, edx, 10000
    sub edi, esi
    mul edx
    mov esi, 100
    jnb lbl9
    cmp edx, 9
    jbe lbl8
    movzx edx, WORD PTR [edx+edx+chartabL]
    add ecx, 8
    mov [ecx-8], edx

  lbl0:
    mul esi

  lbl1:
    movzx edx, WORD PTR [edx+edx+chartabL]
    mov [ecx-6], edx

  lbl2:
    mul esi

  lbl3:
    movzx edx, WORD PTR [edx+edx+chartabL]
    mov [ecx-4], edx

  lbl4:
    mov eax, 28F5C29h
    mul edi

  lbl5:
    movzx edx, WORD PTR [edx+edx+chartabL]
    mov [ecx-2], edx

  lbl6:
    mul esi

  lbl7:
    movzx eax, WORD PTR [edx+edx+chartabL]
    pop edx
    mov [ecx], eax
    pop edi
    lea eax, [ecx+2]
    pop esi
    jmp edx

  lbl8:
    add ecx, 7
    add edx, 48
    mov [ecx-7], edx
    jnz lbl0

  lbl9:
    mul esi
    jnb lbl10
    add ecx, 6
    cmp edx, 9
    ja lbl1
    add edx, 48
    sub ecx, 1
    mov [ecx-5], edx
    jnz lbl2

  lbl10:
    mul esi
    jnb lbl11
    add ecx, 4
    cmp edx, 9
    ja lbl3
    add edx, 48
    sub ecx, 1
    mov [ecx-3], edx
    jnz lbl4

  lbl11:
    mov eax, 28F5C29h
    mul edi
    mov esi, 100
    jnb lbl12
    add ecx, 2
    cmp edx, 9
    ja lbl5
    add edx, 48
    sub ecx, 1
    mov [ecx-1], edx
    jnz lbl6

  lbl12:
    mul esi
    cmp edx, 9
    ja lbl7
    lea eax, [edx+48]
    pop edx
    mov [ecx], eax
    pop edi
    lea eax, [ecx+1]
    pop esi
    jmp edx

utoa_ex endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

;  

end start
